/*XPTUNES_I18N*/
var newPageCount = 0;
var forceAsynchron = false; //set to true if you use xpTunes with track info -> else JR blocks your request
var refreshInterval = 1000;
var poolingStarted = false;
var playingNowId = '';
var playingNowPos = '';
var oldFileId = '';
var args = '';
var getInitValues = false;
started = false;

xpTunes ={
    config:{
        docked: false,
        undocked: false,
		xpTunesURL: 'http://192.168.178.10:8081/',
		ipAddress:'192.168.178.10',
		port:'8081',
		defaultPage:'Imported'
	},
	player:{
        volume: 0,
        mute: false,
		status:'stopped'
	},
	gadget:{
        flyout:false
	}
};
/*********************** global helpers ******************************/
function $(id){ return document.getElementById(id); }
/**************************************COOKIES******************************************/
function setcookie(name, value, expires) {
	//set cookie
    document.cookie = name + "=" + escape(value) + ((expires === null) ? "" : ("; expires=" + expires.toGMTString()));
}
function delCookie(name) {
	//delete cookie
	document.cookie = name + '=;' + ' expires=Thu, 01-Jan-70 00:00:01 GMT';
}
function getcookieval(offset) {
	//get values from cookie
    var endstr = document.cookie.indexOf(';', offset);
    if (endstr == -1) {
		endstr = document.cookie.length;
	}
    return unescape(document.cookie.substring(offset, endstr));
}
function getcookie(name) {
	//get cookie
	var arg = name + "=";
	var alen = arg.length;
	var clen = document.cookie.length;
	var i = 0;
	while (i < clen) {
		var j = i + alen;
		if (document.cookie.substring(i, j) == arg) {return getcookieval (j);}
        i = document.cookie.indexOf(" ", i) + 1;
		if (i === 0) {break;}
	}
	return null;
}
/**************************************MAIN JAVASCRIPT**********************************************/
function setRefreshArgs(commands) {
// 	called from html onload
//	sets arguments for reloading
	args = commands;
}
//function defaultMsg_Text(text){
//		try{
//			var msg_text = $("msg_text");	
//			var msg_area = $("msg_area");	
//			if(msg_text){
//				msg_text.innerHTML = '';
//				msg_area.style.backgroundColor = "transparent";
//			}
//		}catch(ex){}	
//}
function showBar(){
	var ref = $('bar');
	ref.style.display ='inline';
	try{
		ref.filters('alpha').opacity=85;
	} catch(e){}
}
function hideBar(){
		var ref = $('bar');
		ref.style.display ='none';
}
/***********************************RATING*********************************************************/
function setNewRating(fileId,ratingValue,ratingId) {
	var ratHtml='';

	if(fileId != '-1'){
		ratHtml='<ul class="starrating">';
		this.curFileRate = ratingValue;
		
		for(var i = 1; i <= 5; i++){
			ratHtml = ratHtml +'<li><a href="#" onclick="setRatingByFileId('+ fileId +','+ i + ');" title="'+ i +' out of 5 stars" class="star'+i+'">';
			
			if(i > ratingValue){
				ratHtml = ratHtml +'<div class="star0">';
			}else{
				ratHtml = ratHtml +'<div class="star1">';
			}
			
			ratHtml = ratHtml +'</div></a></li>';
		}
		ratHtml = ratHtml +'</ul>';
	}
	return ratHtml;
}
function setRatingByFileId(fileID, rate) {
	oldFileId = fileID;
	command('setRatingByFileId', fileID, rate, false);

	var frating = $("idRating");
	if(frating){
		if(rate == this.curFileRate){
			rate = rate - 1;
		}
		frating.innerHTML = setNewRating(fileID,rate,frating);
	}
}
/**************************************MAIN JRMEDIACENTER**********************************************/
function saveNewFileInfos(jsonObj) {
//save file values to vars and cookie
//first load old values (if present)
	try{
		this.curFileId = jsonObj.Id;
		this.curFileRate = jsonObj.Rating;
		this.curArtist = decodeURIComponent(jsonObj.Artist);
		this.curName = decodeURIComponent(jsonObj.Name);
	}catch(err) {}
}
function clearTrackValues(mode) {
	var hasInnerText = (document.getElementsByTagName("body")[0].innerText !== undefined) ? true : false;
	this.curFileId = '';
	this.curFileRate = '';
	this.curPNPos = '';
	this.curArtist = '';
	this.curName = '';
	this.playingNowId= -1;
	this.playingNowPos=-1;
	
	var fartist = $('idArtist');
	var ftitle = $('idTitle');
	var falbum = $('idAlbum');
	var fcoverFull = $('idCoverFull');
	var frating = $('idRating');
	var fduration2 = $('idDuration');
	var fFooter = $('footer');
//	var fposition = $("position");
//	var fposition2 = $("position2");
//	var fgenre = $("idGenre");
//	var fyear = $("idYear");
//	var fduration = $("duration");
//	var fbar = $('bar');
	
	var cidncText ='';
	var cTitle ='';
	
	if(fFooter){
		fFooter.style.display ='none';
	}
//	if(fbar){
//		fbar.style.display ='none';
//	}

	if (mode=='notconnected'){
		var fplaycontent = $('playcontent');
		var fnotconnected = $('notconnected');
		var finfoLine = $('infoLine');
		
		if(fplaycontent){
			fplaycontent.style.display ='none';
		}
		if(finfoLine){
			finfoLine.style.display ='none';
		}
		if(fnotconnected){
			fnotconnected.style.display ='block';
		}
	}
	if (mode=='clear' ){
	//	cArtist ='not connected';
	//	cTitle = 'waiting for connection';
		var fplaycontent = $('playcontent');
		var fnotconnected = $('notconnected');
		var finfoLine = $('infoLine');
	//	var fspacer1 = $('spacer1');
	//	var fspacer2 = $('spacer2');
	//	var fspacer3 = $('spacer3');
	//	var fspacer4 = $('spacer4');
		
		if(fplaycontent){
			fplaycontent.style.display ='none';
	//		fplaycontent.style.visibility ='hidden';
			
		}
		if(finfoLine){
			finfoLine.style.display ='none';
	//		finfoLine.style.visibility ='hidden';
		}
		if(fnotconnected){
			fnotconnected.style.display ='none';
		}
	}
	if(fcoverFull){
		try{	
			if(fcoverFull.src){		
			//	fcoverFull.src = 'control.cgi?command=getcoverbyid&value=-1&subvalue=medium' ;
				fcoverFull.src = '/images/icon.gif' ;
				fcoverFull.setAttribute('fileid','');
			}
		}catch(pic) {}
	}
	if(fartist){
		if(!hasInnerText){
			fartist.textContent = ''; //cArtist;
		}else{
			fartist.innerText = ''; //cArtist;
		}
		fartist.setAttribute('fileid','');
	}
	if(ftitle){
		if(!hasInnerText){
			ftitle.textContent ='';//cTitle;
		}else{
			ftitle.innerText = '';//cTitle;
		}
		ftitle.setAttribute('fileid','');
	}
//	if(fgenre){
//		if(!hasInnerText){
//			fgenre.textContent ='';
//		}else{
//			fgenre.innerText ='';
//		}
//		fgenre.setAttribute('fileid','');
//	}
//	if(fyear){
//		if(!hasInnerText){
//			fyear.textContent = '';
//		}else{
//			fyear.innerText ='';
//		}
//		fyear.setAttribute('fileid','');
//	}
		if(fduration2){
			if(!hasInnerText){
				fduration2.textContent = '';
			}else{
				fduration2.innerText = '';
			}
		}
		
	if(falbum){
		if(!hasInnerText){
			falbum.textContent = '';
		 }else{
			falbum.innerText = '';
		}
		falbum.setAttribute('fileid','');
	}
	if(frating){
		frating.innerHTML = '';
	}
	//if(fposition){
	//	if(!hasInnerText){
	//		fposition.textContent = '0';
	//	}else{
	//		fposition.innerText  = '0';
	//	}
	//}
	//if(fposition2){
	//	if(!hasInnerText){
	//		fposition2.textContent = '00:00';
	//	 }else{
	//		fposition2.innerText  = '00:00';
	//	}
	//}
	//if(fduration){
	//	if(!hasInnerText){
	//		fduration.textContent = '0';
	//	}else{
	//		fduration.innerText  = '0';
	//	}
	//}
}		
function setNewTrackValues(jsonObj) {
	var hasInnerText = (document.getElementsByTagName('body')[0].innerText !== undefined) ? true : false;

	var fartist = $('idArtist');
	var ftitle = $('idTitle');
	var falbum = $('idAlbum');
	var fcoverFull = $('idCoverFull');
	var frating = $('idRating');
	var fduration2 = $('idDuration');

	document.curFileId=jsonObj.Id;
	this.curFileId=jsonObj.Id;
	if(typeof jsonObj== 'object'){
		var fnotconnected = $('notconnected');
		var fplaycontent = $('playcontent');
		var finfoLine = $('infoLine');
		var artist = jsonObj.Artist;

		if(this.curFileId !=='0'){
			if(finfoLine){
				finfoLine.style.display ='block';
			}
			if(fnotconnected){
				fnotconnected.style.display ='none';
			}
			var fplaycontent = $('playcontent');
			if(fplaycontent){
				fplaycontent.style.display ='block';
			}
		}else{
			var artist = '';
			if(fplaycontent){
				fplaycontent.style.display ='none';
			}
			if(finfoLine){
				finfoLine.style.display ='none';
			}
			if(fnotconnected){
				fnotconnected.style.display ='none';
			}
		}
		
		if(fcoverFull){
			try{	
				if(fcoverFull.src){		
					fcoverFull.src = xpTunes.config.xpTunesURL + 'control.cgi?command=getcoverbyid&value=' + jsonObj.Id +'&subvalue=medium&mediatype=' +jsonObj.MediaType;
					fcoverFull.setAttribute('fileid',jsonObj.Id);
				}
			}catch(pic) {}
		}
		if(fartist){
			if(!hasInnerText){
				fartist.textContent = decodeURIComponent(jsonObj.Artist);
			}else{
				fartist.innerText = decodeURIComponent(jsonObj.Artist);
			}
			fartist.setAttribute('fileid',jsonObj.Id);
		}
		if(falbum){
			if(!hasInnerText){
				falbum.textContent = decodeURIComponent(jsonObj.Album);
			}else{
				falbum.innerText = decodeURIComponent(jsonObj.Album);
			}
			falbum.setAttribute('fileid',jsonObj.Id);
		}
		if(ftitle){
			if(!hasInnerText){
				ftitle.textContent = decodeURIComponent(jsonObj.Name);
			}else{
				ftitle.innerText = decodeURIComponent(jsonObj.Name);
			}
			ftitle.setAttribute('fileid',jsonObj.Id);
		}
	
		if(frating){
			frating.innerHTML = setNewRating(jsonObj.Id,jsonObj.Rating,frating);
		}
			
		if(fduration2){
			if(!hasInnerText){
				fduration2.textContent = jsonObj.Duration2;
			}else{
				fduration2.innerText = jsonObj.Duration2;
			}
		}
	}else{
		clearTrackValues('clear');
	}
}
function checkReloadFrame(jsonObj, refreshtype) {
//check if a frame must be reloaded
	var reload = false;
	var posFound = args.indexOf(refreshtype);
	if (posFound !=-1){
		if(refreshtype == 'trackchange'){
			if(this.curFileId != jsonObj.Id){
				reload = false;
				setNewTrackValues(jsonObj);
			}	
		}else if(refreshtype == 'filechange'){
			if(this.curFileId == jsonObj.Id){
				if(this.curFileRate != jsonObj.Rating){
					reload = false;
					setNewTrackValues(jsonObj);
				}
			}
		}else if(refreshtype == 'updateplaynow'){
			reload = true;
		}
	}else{
		if(posFound===0 && this.itemsfound=="1"){
			history.back();
		}
	
	}
}
/***********************************LAYOUT***********************************************************/
function showRefresh(subtype){
	if (subtype == 'smartlist') {
		var doc = this.document;
		var oe = doc.getElementById('refresh');
		var oldclassName = oe.className;
		var newClassName = oldclassName.replace(/ displayNo/g, "");
		oe.className=newClassName;
	}
}

function checkPlayerState(str) {
//check playerstate
	switch (str.PlayerState) {
		case 'stopped':
			xpTunes.player.state ='stopped';
			var fPlay = $('play');
			var fPause = $('pause');
			fPause.style.display = 'none';
			fPlay.style.display = 'block';
			clearTrackValues('clear');
			if(typeof stopTicker == 'function'){
				stopTicker('');
			}
			if(typeof top.content.stopSlider == 'function'){
				top.content.stopSlider('');
			}
			break;
		case 'paused':
			xpTunes.player.state='paused';
			var fPlay = $('play');
			var fPause = $('pause');

			fPause.style.display = 'block';
			fPlay.style.display = 'none';
			
			if(typeof pauseTicker == 'function'){
				pauseTicker();
			}
			if(typeof top.content.pauseSliderTimer == 'function'){
				top.content.pauseSliderTimer('');
			}
			break;
		case 'playing':
			xpTunes.player.state='playing';
			var fPlay = $('play');
			var fPause = $('pause');
			fPause.style.display = 'block';
			fPlay.style.display = 'none';
			if(typeof startTicker == 'function'){
				startTicker();
			}
			if(typeof top.content.startSlider == 'function'){
				top.content.startSlider('');
			}
			break;
	}
}
function checkChangeTrack(jsonObj) {
	checkReloadFrame(jsonObj, 'trackchange');
	saveNewFileInfos(jsonObj);
}
function checkFileChange(jsonObj) {
	checkReloadFrame(jsonObj, 'filechange');
	saveNewFileInfos(jsonObj);
}

/***********************************CONNECTION***********************************************************/
function commandCallback(jsonArr) {	
//callback from xpTunes Server
//response 2. step
//	console.log("xpTunes:" + jsonArr);
	var jsonObjArr = eval('(' + jsonArr + ')');	

	for (var x = 0; x < jsonObjArr.length; x+=1) {

		started = true;
		try{
			var responseTyp = jsonObjArr[x].response;
			var val = jsonObjArr[x].value;

			if(responseTyp =='inittrackinfo') {
				try{
					checkChangeTrack(val);
				}catch(b){}
			}
			else if(responseTyp =='playerinfo') {
				try{
				checkPlayerState(val);
				setVolume(val);
				}catch(c){}
			}
			else if(responseTyp =='position') {
				try{
				//	setSlider(value);
				//	setSliderPosition(val);
				}catch(d){}
			}	
			else if(responseTyp =='trackchange') {
				try{
					if(val.length !== 0){
						checkChangeTrack(val);
					}
				}catch(f){}
			}
			else if(responseTyp =='filechange') {
				try{
					//checkReloadFrame(val, 'filechange');
					checkFileChange(val, 'filechange');
				}catch(g){}		
			}
			
			else if(responseTyp =='updateplaynow') {
				try{
					checkReloadFrame(val, 'updateplaynow');
				}catch(k){}		
			}
						
			else if(responseTyp =='filelist') {
				try{
					return jsonObjArr;
				}catch(l){}		
			}
			else if(responseTyp =='streamingpath') {
				try{
					return val;
				}catch(m){}		
			}
			else if(responseTyp =='login') {
				try{
					val = jsonObjArr[x].value;
					checkLogin(val);
				}catch(j){}		
			}
			else if(responseTyp =='zonechange'){
				try{
					zoneChange(jsonObjArr);
				}catch(p){}		
			}
			else if(responseTyp =='smartlistrefresh'){
				try{

				}catch(q){}		
			}
		}catch(z){} /*need this catch for error-handling with ie7*/
	}
	started = false;
}
function mousewheelVolume(){
	var newVol=0;
	var fVolume = $('idVolume');	
	var oldVol = fVolume.innerText;
	
	if (event.wheelDelta >= 20){
		newVol = parseInt(oldVol,10) + 1;
		if(newVol > 100){ newVol =100;}
	}else{
		if (event.wheelDelta <= -20){
			newVol= parseInt(oldVol,10) - 1;
			if(newVol < 0){ newVol =0;}
		}
	}
	var hasInnerText = (document.getElementsByTagName("body")[0].innerText !== undefined) ? true : false;
	if(fVolume){
		if(!hasInnerText){
			fVolume.textContent = newVol;
		}else{
			fVolume.innerText = newVol;
		}
			
		command('setvolume',newVol);
	}
}
function addVolume(addVol){
	var newVol=0;
	var fVolume = $('idVolume');	
	var oldVol = fVolume.innerText;
			
	newVol = parseInt(oldVol,10) + parseInt(addVol,10);
	if(newVol > 100){ 
		newVol =100;
	}	
	if(newVol < 0){ 
		newVol =0;
	}
	var hasInnerText = (document.getElementsByTagName("body")[0].innerText !== undefined) ? true : false;
	if(fVolume){
		if(!hasInnerText){
			fVolume.textContent = newVol;
		}else{
			fVolume.innerText = newVol;
		}
		command('setvolume',newVol);
	}
}
function command(action, value, subvalue, synchron) {
// 	sends a synchron/asynchron command to xpTunes server
//	request
	var url='';
	http_request = false;
	value = encodeURIComponent(value);

	/* prevent cache with new Date().valueOf() */
	if( typeof(subvalue) !== null && typeof(subvalue) !=='undefined') {
		if( action == 'playSearchFiles' || action == 'addSearchFiles' || action == 'getSimilarTracksByID' || action == 'getSimilarArtistsByID'  || action == 'addById' || action == 'playById' )    {
			url = value + '&preventCache='+new Date().valueOf();	
		} else {
			url = 'control.cgi?command=' + action + '&value=' + value + '&subvalue=' + subvalue +'&preventCache=' + new Date().valueOf();
		}
			
	}else{
	
		url = 'control.cgi?command=' + action + '&value=' + value + '&preventCache=' + new Date().valueOf();
	}
	url = xpTunes.config.xpTunesURL + url;
    if (window.XMLHttpRequest) { // Mozilla,  Safari, IE7...
		http_request = new XMLHttpRequest();
        if (http_request.overrideMimeType) {
			http_request.overrideMimeType('text/xml');
        }
    }else if (window.ActiveXObject) { // IE6
        try {
            http_request = new ActiveXObject('Msxml2.XMLHTTP');
        }catch (e){
			try {
				http_request = new ActiveXObject('Microsoft.XMLHTTP');
            } catch (c) {}
        }
    } 
    /*    if (!http_request) {
         alert('Ende :( Kann keine XMLHTTP-Instanz erzeugen');
	return false;
	}*/

    var ret;
	
	if (http_request) {
		if(synchron && !forceAsynchron) {
			http_request.open('GET', url, false);
			http_request.onreadystatechange = function (){
				if (http_request.readyState == 4) {
					if (http_request.status == 200) {
						var ret = commandCallback(http_request.responseText);
						return ret;
					}
				}
			};
		} else {
			http_request.onreadystatechange = function (){
				if (http_request.readyState == 4) {
					if (http_request.status == 200) {
						var ret = commandCallback(http_request.responseText);
						return ret;
					}
				}
			};
			http_request.open('GET', url, true);
		}
	}
	http_request.send(null);
    return ret;
}
function pooling() {
//simple pooling -> response to commandCallback
//pooling 3. step
   pool_request = false;
	/* prevent cache with new Date().valueOf() */
	var url = xpTunes.config.xpTunesURL + 'control.cgi?command=update&preventCache=' + new Date().valueOf();
 
    if (window.XMLHttpRequest) { // Mozilla, Safari,...
        pool_request = new XMLHttpRequest();
        if (pool_request.overrideMimeType) {
            pool_request.overrideMimeType('text/xml');
        }
    }

	pool_request.onreadystatechange = function (){
	
		if (pool_request.readyState == 4) {
			if(requestTimer){
				clearTimeout(requestTimer);
				requestTimer=0;
			}
			if (pool_request.status == 200) {
				var ret = commandCallback(pool_request.responseText);
				return ret;
			}
			
			if ((pool_request.status == 204)||(pool_request.status == 1223)) {
				//Nothing found
				return ret;
			}
			if (pool_request.status == 0){
			//||(pool_request.status == 12007)||(pool_request.status == 502))
				getInitValues=true;
			}

			//pool_request.abort();
			//	handleTimeOut();
			//	return ret;
			
			//if (pool_request.status ==0){
			//	return ret;
			//}
		}else if (pool_request.readyState == 0) {
			 //timeout
			if (pool_request.status == 0){
			//||(pool_request.status == 12007)||(pool_request.status == 502))
				getInitValues=true;
			}
		}
	};
		
	if (pool_request){
		if(getInitValues){
			url = xpTunes.config.xpTunesURL + 'control.cgi?command=initvalues&preventCache=' + new Date().valueOf();
			getInitValues = false;
		}
		
		pool_request.open('GET', url, true); 
		//if(pool_request.ontimeout!== undefined){
		//	pool_request.timeout = 800;
		//}
		var requestTimer = setTimeout(function() { pool_request.abort(); clearTrackValues('notconnected');requestTimer=0;}, 800);
		pool_request.send(null);

	}
}
function emulateSetInterval() {
// 	sends a request to xpTunes server all x ms
//	pooling 2. step
	pooling();
	this.setTimeout("emulateSetInterval()", refreshInterval);
}
function startPooling(commands, forceNewSession) {
// 	request values from server to update or refresh site(tick) (onLoad-Event in html)
//	some vars are saved in this section
//	pooling 1. step
	forceNewSession =false;
	if(forceNewSession){
		poolingStarted = false;
	}

	//	fill global values to check later if site should be refreshed
	if(commands.length !== 0){
		args = commands;
	}
	
	clearTrackValues('clear');
	
	if (!(poolingStarted)){
		if(commands.length === 0){
			args =getcookie("args"); 
		}
		
		try{
			emulateSetInterval();
			poolingStarted = true;
		}catch(q){}
	}
}
/***********************************INIT***********************************************************/
function getInitialValues() {
	command('initvalues', '', '', false); //false = FF importend, sonst wirf Browser title beim 1.Start nicht aktualisiert
}

function readPageValues(){
	var pageId = location.hash.substr(2);
	var divAttr = $('divAttr' +pageId );
	try{
		if(divAttr){
			this.page = divAttr.getAttribute("page");
			this.curPageTmp = divAttr.getAttribute("curpagetmp");
			this.subpage = divAttr.getAttribute("subpage");
			this.curPage = divAttr.getAttribute("curpage");
			this.source = divAttr.getAttribute("source");
			this.mediatype = divAttr.getAttribute("mediatype");
			this.searchtype = divAttr.getAttribute("searchtype");
			this.sourceobj = divAttr.getAttribute("sourceobj");
			this.targetobj = divAttr.getAttribute("targetobj");
			this.subvalue = divAttr.getAttribute("subvalue");
			this.searchvalue = divAttr.getAttribute("searchvalue");	 
			this.sort = divAttr.getAttribute("sort");	 
			this.showmaxitems = divAttr.getAttribute("showmaxitems");	
			this.itemsfound = divAttr.getAttribute("itemsfound");
			this.subtype = divAttr.getAttribute("subtype");
			this.searchformula = divAttr.getAttribute("searchformula");
		}
	}catch(ex){}
}
/****************************************COVER***********************************************************/
function getCoverById(fileId) {
//gets cover by fileID
	curloc = window.location.pathname;
	try{
		if(document.artwork_img){
			if(document.artwork_img.src){
				document.artwork_img.src = 'control.cgi?command=getCoverById&value=' + fileId + '&subvalue=small&location=' +curloc ;
			}
		}
	}catch(a){}
}
/***********************************PLAYER/PLAY***********************************************************/
function getPlayerState() {
//get player status
	command('playerstate');
}
function plToggle(fileId) {
// playtoggle 
	if(fileId.length > 0){
		command('playtoggle', fileId);
	}
}
/******************************************EXTRAS***********************************************************/
function spec(e, command, value) {
//Special section to prevent bubbling
// normally not needed 
// only a must use when a link in link is used
// like <div onclick="test1.....<div onclick="test2.....</div></div>
// see here for more informations http://www.quirksmode.org/js/events_order.html
	if (!e) {
		e = window.event;
	}
   
	if (e.stopPropagation) {
		e.stopPropagation();
	} else {
		e.cancelBubble = true;
	}
	if(command=='PlById'){
		PlById(value);		
	}else if(command=='dummy'){
		return false;
	}else{
		alert('No Special command: ' + command);
		return false;
	}
}
function switchMute() {
	var fSpeaker = $('idSpeaker');
	if(fSpeaker){
		if(xpTunes.player.mute =='true'){
			fSpeaker.src = 'images/playercontrol/sound_on.png';
		}else{
			fSpeaker.src = 'images/playercontrol/sound_off.png';
		}
	}
	command('mute');
}
function switchPlayerState(state) {
//changed and checked 21.10.2011
	var fPlay = $('play');
	var fPause = $('pause');

	if (state == 'pausetoggle'){
		if (xpTunes.player.state == 'stopped') {
			xpTunes.player.state = 'playing';
		}else{
			xpTunes.player.state = 'paused';
		}
	}else{
		xpTunes.player.state = 'playing';
	}

	if(fPlay){
		if((xpTunes.player.state == 'playing') || (xpTunes.player.state == 'stopped')){
			fPlay.style.display = 'block';
		} else {
			fPlay.style.display = 'none';
		}
	}
	if(fPause){
		if((xpTunes.player.state == 'playing') || (xpTunes.player.state == 'stopped')){
			fPause.style.display = 'none';
		} else {
			fPause.style.display = 'block';
		}
	}

	command(state,'');
}
function setVolume(jsonObj) {
	var fVolume, fSpeaker, fPlay, fPause, fFooter;
	try{
		fVolume = $('idVolume');
		fSpeaker = $('idSpeaker');
		fPlay = $('play');
		fPause = $('pause');
		fFooter = $('footer');
		xpTunes.player.mute = jsonObj.Mute;
		xpTunes.player.volume = jsonObj.Volume;
		xpTunes.player.state = jsonObj.PlayerState;
	}catch(err) {}	
		
	if(fFooter){
		fFooter.style.display ='block';
	}		
	if(fVolume){
		if(xpTunes.player.volume !== undefined){
			fVolume.innerText  = xpTunes.player.volume;
		} else {
			fVolume.innerText  = '0';
		}
	}
	if(fSpeaker){
		 if(xpTunes.player.mute =='true'){
				fSpeaker.src = 'images/playercontrol/sound_off.png';
		 } else {
				fSpeaker.src = 'images/playercontrol/sound_on.png';
		 }
	}

	if(fPlay){
		if(xpTunes.player.state == 'paused' || xpTunes.player.state == 'waiting' ){
			fPlay.style.display = 'none';
		} else{
			fPlay.style.display = 'block';
		}
	}
	
	if(fPause){
		if(xpTunes.player.state == 'paused' || xpTunes.player.state == 'waiting'){
			fPause.style.display = 'block';
		} else{
			fPause.style.display = 'none';
		}
	}
}

/**************************************gadget******************************************/
function initGadget(){
	try{
		//System.Debug.outputString('initGadget');
		// Setttings page
		System.Gadget.settingsUI = "settings.html";
		// Flyout
		System.Gadget.Flyout.file = "flyoutFrame.html";
		// Delegate for when the Settings dialog is closed.
		System.Gadget.onSettingsClosed = SettingsClosed;
		// Delegate for when the Settings dialog is instantiated.
		System.Gadget.onShowSettings = SettingsShow;
		// Delegate for when the Flyout dialog is instantiated.
		// System.Gadget.Flyout.onShow = showingFlyout;
		
		// Apply current settings
		ApplySettings();	
	
	}catch(e){
		//alert(e.message);
	}
}

// --------------------------------------------------------------------
// Handle the Settings dialog closed event.
// event = System.Gadget.Settings.ClosingEvent argument.
// --------------------------------------------------------------------
function SettingsClosed(event){
    // User hit OK on the settings page.
    if (event.closeAction == event.Action.commit){
		readSettings();
		getInitialValues();
    }
}
// --------------------------------------------------------------------
// Handle the Settings dialog show event.
// --------------------------------------------------------------------
function SettingsShow(){
  //  SetContentText("Settings opening.");
}
function ApplySettings(){
 //	System.Debug.outputString('ApplySettings');
	readSettings();
}
function readSettings(){
 //	System.Debug.outputString('readSettings');
	var str = System.Gadget.Settings.readString('IPADDRESS');
	if( str == ''){
		 System.Gadget.Settings.writeString('IPADDRESS', xpTunes.config.ipAddress);
    }else{
        xpTunes.config.ipAddress = str;
	}

    str = System.Gadget.Settings.readString('PORT');
    if( str == ''){
		System.Gadget.Settings.writeString('PORT', xpTunes.config.port);
    }else{
        xpTunes.config.port = str;
	}
    str = System.Gadget.Settings.readString('DEFAULTPAGE');
    if( str == ''){
		System.Gadget.Settings.writeString('DEFAULTPAGE', xpTunes.config.defaultPage);
    }else{
        xpTunes.config.defaultPage = str;
	}

	xpTunes.config.xpTunesURL = 'http://' + xpTunes.config.ipAddress + ':' + xpTunes.config.port +'/';
	System.Gadget.Settings.writeString('XPTUNESURL', xpTunes.config.xpTunesURL);
}

function toggleFlyout(){
	System.Gadget.Flyout.show = !System.Gadget.Flyout.show;
}
function hideFlyout(){
	System.Gadget.Flyout.show = false;
}
//function showingFlyout(){
//	System.Gadget.Flyout.document.parentWindow.iFrameBox.innerHTML = '<iframe id="htmlFrame" name="htmlFrame" width="100%" height="100%" frameborder="0" src="' + xpTunes.config.xpTunesURL + 'xadget/flyout/index.html?test.html"></iframe>';
//}
